#!/usr/bin/env python

import os
import logging
import logging.handlers
from os.path import *
from commands import *

from OVSXMasterFailover import *
from OVSServerProxy import ServerProxy
from OVSProtocol import *
from OVSCommons import *
from OVSCDS import *

import utils.do_rpc

ADMIN_SP = ServerProxy(utils.do_rpc.get_local_agt_url())

#======================================================================
#setup the logging system, no dependency to the log server.

formatter = logging.Formatter(fmt="%(asctime)s %(levelname)s=> %(message)s", datefmt="%Y-%m-%d %H:%M:%S")
handler = logging.handlers.RotatingFileHandler(join(LOG_DIR, "ovs_autorun.log"), "a", 1024*1024, 3)
handler.setFormatter(formatter)
logging.getLogger("").setLevel(logging.DEBUG)
logging.getLogger("").addHandler(handler)

#======================================================================
#user defined stop/cleanup function

def teardown_master_env():
    try:
        rs = clusterm_cleanup_master_env()
        GETVAL(rs)
    except Exception, e:
        errmsg = fmt_err_msg(e)
        logging.error("teardown_master_env: => %s" % errmsg)

#======================================================================
#autorun jobs
JOBS = [
    ["function", "teardown_master_env", ()],
]

def main():
    logging.info("----------------------AUTO STOP--------------------------")
    for job in JOBS:
        try:
            logging.info("%s" % (repr(job),))
            if job[0] == "do_rpc":
                operation, param = job[1:]
                getattr(ADMIN_SP, operation)(*param)
            elif job[0] == "command":
                cmd = job[1]
                run_cmd_bg(cmd)
            elif job[0] == "function":
                func_name, param = job[1:]
                eval(func_name)(*param)
        except Exception, e:
            errmsg = fmt_err_msg(e)
            logging.error("%s => %s" % (repr(job), errmsg))
    logging.info("--------------------------END----------------------------")

if __name__ == "__main__":
    main()

