#!/usr/bin/env python
#^#
# OVSConstants.py
#
# <description>
#
#
# Copyright (C) 2006, 2007 Oracle.  All rights reserved.
#
# This program is free software; you can redistribute it and/or
# modify it under the terms of the GNU General Public
# License as published by the Free Software Foundation, version 2.
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
# General Public License for more details.
# You should have received a copy of the GNU General Public
# License along with this program; if not, write to the
# Free Software Foundation, Inc., 59 Temple Place - Suite 330,
# Boston, MA 021110-1307, USA.
#$#

#agent home
from os.path import dirname, realpath
AGENT_DIR   = dirname(realpath(__file__))

#ovs base
OVS_BASE    = "/OVS"
OVS_MOUNT   = "/var/ovs/mount"

#agent config
CONFIG_DIR  = "/etc/ovs-agent"
#the local info are on shared storage, mainly for HA
CONFIG_DIR_CLUSTER_BASENAME = ".ovs-agent"
CONFIG_DIR_CLUSTER          ="%s/%s" % (OVS_BASE, CONFIG_DIR_CLUSTER_BASENAME)

#defaut values
DEFAULT_AGENT_USERNAME  = "oracle"
DEFAULT_AGENT_PASSWD    = "oracle"
DEFAULT_AGENT_PORT      = 8899

#storage configuration
STORAGE_REPO_CONFIG = "/etc/ovs/repositories"
SR_REPO_META        = ".ovsrepo"
#oracle vm system config
OVS_CONFIG          = "/etc/ovs-config"
#disk space reserved for cluster configurations (MB)
RESERVED_SPACE = 100
#hard limits imposed by xen
HVM_IDE_MAX_NUM     = 4
HVM_SCSI_MAX_NUM    = 7

#runtime dir
PID_DIR                     = '/var/run/ovs-agent'
SHUTDOWN_FLAG               = "%s/OVSAgentServer.shutdown" % PID_DIR
AGENT_SHUTDOWN_MODE_FLAG    = "%s/shutdown_mode" % PID_DIR
LOG_DIR                     = '/var/log/ovs-agent'

#ha & cluster
AGENT_GUARD_PROCESS     = "%s/OVSAgentGuard.py" % AGENT_DIR
AGENT_LIVENESS_LOCK     = "%s/agent.heart" % PID_DIR
DLM                     = "/dlm"
DLM_DOMAIN              = "/dlm/ovm"
DLM_LOCK_MASTER         = "/dlm/ovm/master"
HA_NFS_HEARTBEAT_FILE   = "/OVS/.server_pool_hb"
HA_TOUCH_PREFIX         = ".ha_"
OCFS2_CLUSTER_CONF      = "/etc/ocfs2/cluster.conf"
SR_HEARTBEAT_FILE       = ".server_pool_hb"
HEARTBEAT_STATUS_ACTIVE     = "Active"
HEARTBEAT_STATUS_INACTIVE   = "Inactive"

#compat
COMPAT_PRFIX        = "/opt/oracle"
COMPAT_SBIN         = "%s/usr/sbin" % COMPAT_PRFIX
COMPAT_LIB          = "%s/usr/lib" % COMPAT_PRFIX
COMPAT_PYTHON_LIB   = "%s/usr/lib/python2.4/site-packages" % COMPAT_PRFIX

