#######################################################################
#ERROR CODE LOOKUP TABLE
#miscellaneous
ERR_RAW_MESSAGE                 = "00000"
ERR_CDS_LOCK_TIMOUT             = "00001"
ERR_INTERNAL_ERROR              = "00002"
ERR_AGENT_DB_NOT_FOUND          = "00003"

#connection
ERR_SERVER_CONNECTION           = "10000"
ERR_AGENT_CONNECTION            = "10001"
ERR_AGENT_PASSWD_INCORRECT      = "10002"
ERR_AGENT_METHOD_NOT_SUPPORT    = "10003"
ERR_AGENT_CONNECTION_TIMEOUT    = "10004"

#pool resource
ERR_NO_MEMORY                   = "20000"
ERR_NO_HVM_SUPPORT              = "20001"
ERR_NO_UTILITY_SERVER           = "20002"
ERR_NO_SERVER_SELECTED          = "20003"

#vm
ERR_VM_NOT_RUNNING              = "30000"
ERR_VM_RUNNING                  = "30001"

#storage
ERR_VM_NOT_FOUND                = "40000"
ERR_SR_NO_REPO_META             = "40001"

#cluster & HA
ERR_CLUSTER_NO_HEATBEAT         = "50000"
ERR_OVS_IS_MOUNTPOINT           = "50001"
ERR_OVS_NOT_LINK                = "50002"
ERR_CLUSTER_ROOT_NOT_MOUNT      = "50003"
ERR_NO_CLUSTER_ROOT_SR          = "50004"
ERR_SYNC_AGENT_CONFIG           = "50005"
ERR_DO_ON_SERVERS               = "50006"
ERR_SR_NO_HEARTBEAT_FILE        = "50007"
ERR_NO_MASTER_CANDIDATE         = "50008"
ERR_NO_HEARTBEAT                = "50009"

#network

#agent status
ERR_SHUTDOWN_MODE               = "70001"


ERROR_DICT = {
#{<error_code: message template, causes, action>}

#======================================================================
#miscellaneous
ERR_RAW_MESSAGE: (
"""Unexpected error: $errmsg""",
"""
""",
"""
""",
),

ERR_CDS_LOCK_TIMOUT: (
"""CDS accquire lock $lock_file timeout. locker process is $locker.""",
"""
""",
"""
""",
),

#ERR_INTERNAL_ERROR                    = "00002"
ERR_INTERNAL_ERROR: (
"""Internal Error. message='$errmsg'
""",
"""
""",
"""
""",
),


#ERR_AGENT_DB_NOT_FOUND                 = "00003"
ERR_AGENT_DB_NOT_FOUND: (
"""key=$key not found in agent db=$db.
""",
"""
""",
"""
""",
),

#======================================================================
#server/agent connection

#socket error! code=113, msg=No route to host
#socket error! code=-5, msg=No address associated with hostname
ERR_SERVER_CONNECTION: (
"""Cannot connect to server($hostname) agent. Remote server down.""",
"""1) Remote server down.
2) Connect to server that does not exist.
3) Connect to a wrong port.
""",
"""
"""
),

#socket error! code=111, msg=Connection refused
#agent down
#socket error! code=104, msg=Connection reset by peer
#connect to agent use http instead of https.
ERR_AGENT_CONNECTION: (
"""Cannot connect to server($hostname) agent. Agent down or protocol error.""",
"""
""",
"""
""",
),

#<ProtocolError for oracle:orac1e@ovs-dev4:8899/RPC2: 403 Unauthorized HTTP Access Attempt from ('10.182.120.56', 47190)!>
ERR_AGENT_PASSWD_INCORRECT: (
"""Cannot connect to server($hostname) agent. Agent password incorrect.""",
""" """,
""" """,
),

# exceptions.Exception:method: <***> not supported!
ERR_AGENT_METHOD_NOT_SUPPORT: (
"""Remote Agent does not support the calling method.""",
"""
1) Agent version on remote server may be too old.
""",
"""
""",
),

#ERR_AGENT_CONNECTION_TIMEOUT    = "10004"
ERR_AGENT_CONNECTION_TIMEOUT: (
"""Connect to server($hostname) agent timeout.""",
"""
""",
"""
""",
),



#======================================================================
#pool resource

ERR_NO_MEMORY: (
"""No enough memory to run vm($vm_path), required memory=$memory.""",
"""
""",
"""
""",
),

ERR_NO_HVM_SUPPORT: (
"""No hardware virtualization support to run vm ($vm_path).""",
"""1) Server does not have vt support.
2) Server's vt support is not enabled in BIOS.
""",
"""
""",
),

ERR_NO_UTILITY_SERVER: (
"""No Utility Server available.""",
"""1) No Utility Server configured in the cluster.
""",
"""
""",
),

ERR_NO_SERVER_SELECTED: (
"""No server selected.""",
"""Possible cause:
1) No enough memory
2) No HVM support
""",
"""
""",
),

#======================================================================
#vm status

ERR_VM_RUNNING: (
"""vm($vm_path) already running.""",
"""1) Try to start a vm that already running.
""",
"""
""",
),

ERR_VM_NOT_RUNNING: (
"""vm($vm_path) not running.""",
"""1) Try to get a vm's attribute but the vm is down.
2) Try to shutdown a vm that is not running.
""",
"""
""",
),


#======================================================================
#storage
#ERR_VM_NOT_FOUND                = "40000"
ERR_VM_NOT_FOUND: (
"""vm($vm_path) cannot be found.
""",
"""1) vm has been deleted.
2) Storage does not mount properly.
""",
"""
""",
),

#ERR_SR_NO_REPO_META             = "40001"
ERR_SR_NO_REPO_META: (
"""Repository metadata file does not exist in ('$path').
""",
"""1) Not a SR.
2) SR is not correctly mounted.
""",
"""
""",
),


#======================================================================
#cluster & HA
#ERR_CLUSTER_NO_HEATBEAT        = "50000"
ERR_CLUSTER_NO_HEATBEAT: (
"""No active heartbeat for the ocfs2 cluster.
""",
"""1)Service o2cb is not properly started.
2)Cluster root is on ocfs2 SR, which is not mounted.
3)Cluster root is on NFS SR, the heartbeat is not started.
""",
"""
""",
),


#ERR_OVS_IS_MOUNTPOINT          = "50001"
ERR_OVS_IS_MOUNTPOINT: (
"""Cluster root (/OVS) is a mount point which is not mounted by ovs-agent.
""",
"""1) Cluster root is not mounted in /OVS anymore in Oracle VM 3.0.
""",
"""
Please do the migration properly from previous version.
""",
),

#ERR_OVS_NOT_LINK                = "50002"
ERR_OVS_NOT_LINK: (
"""Cluster root (/OVS) is not a link. in Oracle VM 3.0, /OVS is a link
to the real cluster root SR.
""",
"""
""",
"""
""",
),

#ERR_CLUSTER_ROOT_NOT_MOUNT      = "50003"
ERR_CLUSTER_ROOT_NOT_MOUNT: (
"""Cluster root /OVS('$path') is not SR mount point.
""",
"""1) The SR for cluster root is not properly mounted.
""",
"""
""",
),

#ERR_NO_CLUSTER_ROOT_SR          = "50004"
ERR_NO_CLUSTER_ROOT_SR: (
"""Cluster root SR not found in db.
""",
"""1)Not assign cluster root SR yet.
""",
"""
""",
),

#ERR_SYNC_AGENT_CONFIG           = "50005"
ERR_SYNC_AGENT_CONFIG: (
"""Cannot sync agent config from $src_path to $dst_path.
""",
"""
""",
"""
""",
),

#ERR_DO_ON_SERVERS               = "50006"
ERR_DO_ON_SERVERS: (
"""Do '$operation' on servers ('$hostnames') failed.
""",
"""
""",
"""
""",
),


#ERR_SR_NO_HEARTBEAT_FILE        = "50007"
ERR_SR_NO_HEARTBEAT_FILE: (
"""Heartbeat file ('$hb_file') not exists.
""",
""" 1) When trying to start heartbeat on a nfs cluster root, no heartbeat
file is created beforehand.
""",
"""
""",
),

#ERR_NO_MASTER_CANDIDATE         = "50008"
ERR_NO_MASTER_CANDIDATE: (
"""No candidate for next master server.
""",
"""
""",
"""
""",
),

#ERR_NO_HEARTBEAT                = "50009"
ERR_NO_HEARTBEAT: (
"""No cluster heartbeat.
""",
"""
""",
"""
""",
),

#======================================================================
#agent status
ERR_SHUTDOWN_MODE: (
"""Agent currently work in shutdown mode. operation not allowed.
""",
"""
""",
"""
""",
),

#======================================================================
} #END

########################################################################
#ERROR GROUP
ERRGRP_SERVER_SELECTION         = "ServerSelectionException"
ERRGRP_AGENT_CONNECTION         = "AgentConnectionException"

ERRGRP_DICT = {
ERRGRP_SERVER_SELECTION: ["20000", "20001", "20002"],
ERRGRP_AGENT_CONNECTION: ["10000", "10001", "10002", "10004"],
}
