#!/usr/bin/env python
import string

from OVSConstants import *

#----------------------------------------------------------------------
def parse_shared_fs():
    shared_fs, shared_fs_type, shared_fs_line = "", "", ""
    #f = open("/proc/mounts")
    #FIXME:
    #entry in /proc/mounts may not be consistent with mount
    #mount -t nfs -o rw,sync,vers=3,rsize=32768,wsize=32768,hard,proto=tcp,timeo=600,retrans=2,sec=sys,addr=ostest105.cn.oracle.com ostest105.cn.oracle.com:/OVS /OVS
    #the addr=ostest105.cn.oracle.com option is not recognized by mount
    f = open("/etc/mtab")
    try:
        for line in f:
            parts = line.split()
            if parts[1] == OVS_BASE:
                #bugz#6707
                if shared_fs:
                    raise Exception("more than one filesystems are mounted on /OVS, please verify.")
                shared_fs, shared_fs_type = parts[0], parts[2]
                shared_fs_line = line
    finally:
        f.close()

    return shared_fs, shared_fs_type, shared_fs_line

#----------------------------------------------------------------------
def parse_ocfs2_cluster_conf(cfg_file=OCFS2_CLUSTER_CONF):
    """
    @return: {"nodes":[<dict of node>], "cluster": <dict of cluster>}
    """
    conf_dict = { "nodes": [], "cluster": {}}

    f = open(cfg_file)
    try:
        for line in f:
            line = line.strip()
            if not line or line.startswith("#"):
                continue
            elif line.startswith("node:"):
                d = {}
                conf_dict["nodes"].append(d)
            elif line.startswith("cluster:"):
                #cluster with default name=ocfs2
                d = {"name": "ocfs2"}
                conf_dict["cluster"] = d
            else:
                parts = map(string.strip, line.split("="))
                if len(parts) == 2:
                    d[parts[0]] = parts[1]
    finally:
        f.close()

    return conf_dict

#alias
parse_cluster_conf = parse_ocfs2_cluster_conf

#----------------------------------------------------------------------

