#!/usr/bin/env python
#^#
#
# <description>
#
#
# Copyright (C) 2006, 2007 Oracle.  All rights reserved.
#
# This program is free software; you can redistribute it and/or
# modify it under the terms of the GNU General Public
# License as published by the Free Software Foundation, version 2.
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
# General Public License for more details.
# You should have received a copy of the GNU General Public
# License along with this program; if not, write to the
# Free Software Foundation, Inc., 59 Temple Place - Suite 330,
# Boston, MA 021110-1307, USA.
#$#

import time
from xen.xend.XendAuthSessions import XendAuthSessions
from xen.xend import uuid
from OVSCDS import CDS

class OVSXendAuthSessions(XendAuthSessions):
    def __init__(self):
        pass

    def login_unconditionally(self, username):
        """Returns a session UUID if valid.

        @rtype: string
        @return: Session UUID
        """
        new_session = uuid.createString()
        cds = CDS("session")
        try:
            cds.db_session[new_session] = (username, time.time())
        finally:
            cds.close()

        return new_session

    def logout(self, session):
        """Delete session of it exists."""
        cds = CDS("session")
        try:
            if session in cds.db_session:
                del cds.db_session[session]
        finally:
            cds.close()

    def is_session_valid(self, session):
        """Returns true is session is valid."""
        rs = False
        cds = CDS("session")
        try:
            if session in cds.db_session:
                rs = True
        finally:
            cds.close()

        return rs

    def get_user(self, session):
        user = None
        cds = CDS("session")
        try:
            if session in cds.db_session:
                user = cds.db_session[session][0]
        finally:
            cds.close()

        return user

def instance():
    """Singleton constructor. Use this instead of the class constructor.
    """
    global inst
    try:
        inst
    except:
        inst = OVSXendAuthSessions()
        inst.init()
    return inst
