# Copyright (C) 2009 Oracle.  All rights reserved.
#
# This program is free software; you can redistribute it and/or
# modify it under the terms of the GNU General Public
# License as published by the Free Software Foundation, version 2.
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
# General Public License for more details.
# You should have received a copy of the GNU General Public
# License along with this program; if not, write to the
# Free Software Foundation, Inc., 59 Temple Place - Suite 330,
# Boston, MA 021110-1307, USA.
from OVSCDS import CDS

def _get_server_mode():
    cds = CDS('LOCK_SH,LOCAL_DB', 'server_mode')
    return cds.db_server_mode['mode']

def _set_server_mode(mode):
    cds = CDS('LOCAL_DB', 'server_mode')
    cds.db_server_mode['mode'] = mode
    cds.close()
        
def _is_maintenance_mode():
    try:
        cds = CDS('LOCAL_DB,LOCK_SH', 'server_mode')
        return cds.db_server_mode['mode'] == 'maintain'
    except:
        return False
