#!/usr/bin/env python

import commands

def is_local_ocfs2(dev_spec):
    cmd = "debugfs.ocfs2 %s <<< stats 2>/dev/null | grep 'Feature Incompat'" % dev_spec
    (status, output) = commands.getstatusoutput(cmd)
    if "local" in output.lower():
        return True
    else:
        return False

from OVSFileSP import FileSP
class OVSSPOCFS2(FileSP):
    @classmethod
    def get_plugin_info(klass):
        return {
            "vendor name": "Oracle",
            "description": "OCFS2 File Based Storage Provider",
            "plugin version": "0.0.1",
        }

    def __init__(self, fs_spec):
        FileSP.__init__(self, fs_spec)

    @property
    def info(self):
        return self.__dict__

    @property
    def fs_type(self):
        if is_local_ocfs2(self.fs_spec):
            return "ocfs2.local"
        else:
            return "ocfs2.cluster"
