#!/usr/bin/env python
#^#
# db_dump.py
#
# <description>
#
#
# Copyright (C) 2006, 2007 Oracle.  All rights reserved.
#
# This program is free software; you can redistribute it and/or
# modify it under the terms of the GNU General Public
# License as published by the Free Software Foundation, version 2.
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
# General Public License for more details.
# You should have received a copy of the GNU General Public
# License along with this program; if not, write to the
# Free Software Foundation, Inc., 59 Temple Place - Suite 330,
# Boston, MA 021110-1307, USA.
#$#
from os.path import *
import sys
sys.path.append(join(dirname(__file__), ".."))

import getopt
import OVSCDS
from OVSCommons import *

def db_dump(db_name):
    d = OVSCDS.db_dump(db_name)
    for k, v in d.items():
        if hasattr(v, "__dict__"):
            print "%s\t=>\t%s" % (k,v.__dict__)
        else:
            print "%s\t=>\t%s" % (k,v)

def usage():
    print """Usage: %s <[db_flag,]db_name>
    if db_flag=LOCAL_DB, using db in /etc/ovs-agent/db/*,
    otherwise /OVS/.ovs-agent/db/*.""" % sys.argv[0]

if __name__ == "__main__":
    try:
        opts, argv = getopt.gnu_getopt(sys.argv[1:], "h", ["help",])
    except getopt.GetoptError:
        usage()
        sys.exit(1)
    help = False
    for o, a in opts:
        if o in ("-h", "--help"):
            help = True

    if help or len(argv) != 1:
        usage()
        sys.exit(1)

    db_name = sys.argv[1]
    if db_name.endswith(".db"):
        db_name = db_name[:-3]

    db_dump(db_name)

