#!/usr/bin/env python
#^#
#
# Copyright (C) 2006, 2007 Oracle.  All rights reserved.
#
# This program is free software; you can redistribute it and/or
# modify it under the terms of the GNU General Public
# License as published by the Free Software Foundation, version 2.
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
# General Public License for more details.
# You should have received a copy of the GNU General Public
# License along with this program; if not, write to the
# Free Software Foundation, Inc., 59 Temple Place - Suite 330,
# Boston, MA 021110-1307, USA.
#$#

from os.path import dirname, realpath
import sys
agent_dir = dirname(dirname(realpath(__file__)))
sys.path.append(agent_dir)

import xmlrpclib
from OVSProtocol import *
from do_rpc import get_local_agt_url

if __name__ == "__main__":
    try:
        print "This is a cleanup script for ovs-agent."
        print "It will try to do the following:\n"
        print "*) stop o2cb heartbeat"
        print "*) offline o2cb"
        print "*) remove o2cb configuration file"
        print "*) umount ovs-agent storage repositories"
        print "*) cleanup ovs-agent local database"
        yn = raw_input("\nWould you like to continue? [y/N] ")
    except:
        print "\nCleanup canceled."
        sys.exit(1)

    if yn.lower() in ("y", "yes"):
        agt_url = get_local_agt_url()
        sp = xmlrpclib.ServerProxy(agt_url)
        try:
            sp.echo("")
        except:
            print >> sys.stderr, "Cleanup failed: ovs-agent not runnning?"
            sys.exit(1)

        ret = sp.clusterm_teardown()
        ret = DJSON(JSON(ret))
        if ret["status"] == OP_STATUS_FAIL:
            print >> sys.stderr, "Cleanup failed: %s" % ret["error"]["errmsg"]
        else:
            print "Cleanup done."
