#!/usr/bin/env python
#^#
#
# Copyright (C) 2006, 2007 Oracle.  All rights reserved.
#
# This program is free software; you can redistribute it and/or
# modify it under the terms of the GNU General Public
# License as published by the Free Software Foundation, version 2.
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
# General Public License for more details.
# You should have received a copy of the GNU General Public
# License along with this program; if not, write to the
# Free Software Foundation, Inc., 59 Temple Place - Suite 330,
# Boston, MA 021110-1307, USA.
#$#

from os.path import dirname, realpath
import sys
sys.path.append(dirname(dirname(realpath(__file__))))

import xmlrpclib
from getopt import getopt, GetoptError
from do_rpc import get_local_agt_url

agt_url = get_local_agt_url()
sp = xmlrpclib.ServerProxy(agt_url)


def usage():
    print >>sys.stderr, "%s --name <name> --uuid <uuid> --reason <reason>" % __file__

if __name__ == "__main__":
    try:
        opts, args = getopt(sys.argv[1:], "n:u:r:", ["name=", "uuid=", "reason="])
    except GetoptError:
        usage()
        sys.exit(2)

    if not opts or args:
        usage()
        sys.exit(2)

    name, uuid, reason = "", "", ""
    for o, a in opts:
        if o in ("-n", "--name"):
            name = a
        if o in ("-u", "--uuid"):
            uuid = a
        elif o in ("-r", "--reason"):
            reason = a

    if not name or not reason:
        usage()
        sys.exit(2)

    try:
        sp.echo("whatever")
    except Exception, e:
        print "Cannot establish a connection to ovs-agent:", e
        sys.exit(3)

    output = ""
    try:
        output = sp.ha_hook_vm_shutdown(name, reason)
    except Exception, e:
        print >>sys.stderr, e
        sys.exit(3)

    if output.startswith("success"):
        print >>sys.stdout, output
        sys.exit(0)
    else:
        print >>sys.stderr, output
        sys.exit(1)
