#!/usr/bin/env python
#
#^#
# Copyright (C) 2006, 2007 Oracle.  All rights reserved.
#
# This program is free software; you can redistribute it and/or
# modify it under the terms of the GNU General Public
# License as published by the Free Software Foundation, version 2.
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
# General Public License for more details.
# You should have received a copy of the GNU General Public
# License along with this program; if not, write to the
# Free Software Foundation, Inc., 59 Temple Place - Suite 330,
# Boston, MA 021110-1307, USA.
#$#

from os.path import dirname, join
import sys
sys.path.append(join(dirname(__file__), ".."))

from OVSCDS import *
from OVSConstants import *

import logging
import logging.handlers

#======================================================================
#setup the logging system, no dependency to the log server.

formatter = logging.Formatter(fmt="%(asctime)s %(levelname)s=> %(message)s", datefmt="%Y-%m-%d %H:%M:%S")
handler = logging.handlers.RotatingFileHandler(join(LOG_DIR, "ovs_upgrade.log"), "a", 1024*1024, 3)
handler.setFormatter(formatter)
logging.getLogger("").setLevel(logging.DEBUG)
logging.getLogger("").addHandler(handler)

#======================================================================

def set_master_agt_url():
    master_hostname = db_load("cluster", "master_hostname", get=True)
    if master_hostname:
        master_agt_url = db_load("cluster", "master_agt_url", get=True)
        if not master_agt_url:
            logging.debug("Master agent url missing.")
            master_srv = db_load("srv", master_hostname)
            master_agt_url = master_srv["agt_url"]
            db_save("cluster", "master_agt_url", master_agt_url)
            logging.debug("Master agent url reset.")


if __name__ == "__main__":
    # for 2.2.0 to 2.2.1 upgrade
    set_master_agt_url()
